# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.25.0
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' OptionUnusualTrade Class
#'
#' @field symbol 
#' @field timestamp 
#' @field type 
#' @field total_value 
#' @field contract_type 
#' @field contract_expiration 
#' @field contract_strike 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
OptionUnusualTrade <- R6::R6Class(
  'OptionUnusualTrade',
  public = list(
    `symbol` = NA,
    `timestamp` = NA,
    `type` = NA,
    `total_value` = NA,
    `contract_type` = NA,
    `contract_expiration` = NA,
    `contract_strike` = NA,
    initialize = function(`symbol`, `timestamp`, `type`, `total_value`, `contract_type`, `contract_expiration`, `contract_strike`){
      if (!missing(`symbol`)) {
        self$`symbol` <- `symbol`
      }
      if (!missing(`timestamp`)) {
        self$`timestamp` <- `timestamp`
      }
      if (!missing(`type`)) {
        self$`type` <- `type`
      }
      if (!missing(`total_value`)) {
        self$`total_value` <- `total_value`
      }
      if (!missing(`contract_type`)) {
        self$`contract_type` <- `contract_type`
      }
      if (!missing(`contract_expiration`)) {
        self$`contract_expiration` <- `contract_expiration`
      }
      if (!missing(`contract_strike`)) {
        self$`contract_strike` <- `contract_strike`
      }
    },
    toJSON = function() {
      OptionUnusualTradeObject <- list()
      if (!is.null(self$`symbol`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`symbol`) && ((length(self$`symbol`) == 0) || ((length(self$`symbol`) != 0 && R6::is.R6(self$`symbol`[[1]]))))) {
          OptionUnusualTradeObject[['symbol']] <- lapply(self$`symbol`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['symbol']] <- jsonlite::toJSON(self$`symbol`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`timestamp`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`timestamp`) && ((length(self$`timestamp`) == 0) || ((length(self$`timestamp`) != 0 && R6::is.R6(self$`timestamp`[[1]]))))) {
          OptionUnusualTradeObject[['timestamp']] <- lapply(self$`timestamp`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['timestamp']] <- jsonlite::toJSON(self$`timestamp`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`type`) && ((length(self$`type`) == 0) || ((length(self$`type`) != 0 && R6::is.R6(self$`type`[[1]]))))) {
          OptionUnusualTradeObject[['type']] <- lapply(self$`type`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['type']] <- jsonlite::toJSON(self$`type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`total_value`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`total_value`) && ((length(self$`total_value`) == 0) || ((length(self$`total_value`) != 0 && R6::is.R6(self$`total_value`[[1]]))))) {
          OptionUnusualTradeObject[['total_value']] <- lapply(self$`total_value`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['total_value']] <- jsonlite::toJSON(self$`total_value`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`contract_type`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`contract_type`) && ((length(self$`contract_type`) == 0) || ((length(self$`contract_type`) != 0 && R6::is.R6(self$`contract_type`[[1]]))))) {
          OptionUnusualTradeObject[['contract_type']] <- lapply(self$`contract_type`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['contract_type']] <- jsonlite::toJSON(self$`contract_type`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`contract_expiration`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`contract_expiration`) && ((length(self$`contract_expiration`) == 0) || ((length(self$`contract_expiration`) != 0 && R6::is.R6(self$`contract_expiration`[[1]]))))) {
          OptionUnusualTradeObject[['contract_expiration']] <- lapply(self$`contract_expiration`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['contract_expiration']] <- jsonlite::toJSON(self$`contract_expiration`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`contract_strike`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`contract_strike`) && ((length(self$`contract_strike`) == 0) || ((length(self$`contract_strike`) != 0 && R6::is.R6(self$`contract_strike`[[1]]))))) {
          OptionUnusualTradeObject[['contract_strike']] <- lapply(self$`contract_strike`, function(x) x$toJSON())
        } else {
          OptionUnusualTradeObject[['contract_strike']] <- jsonlite::toJSON(self$`contract_strike`, auto_unbox = TRUE)
        }
      }

      OptionUnusualTradeObject
    },
    fromJSON = function(OptionUnusualTradeJson) {
      OptionUnusualTradeObject <- jsonlite::fromJSON(OptionUnusualTradeJson)
      if (!is.null(OptionUnusualTradeObject$`symbol`)) {
        self$`symbol` <- OptionUnusualTradeObject$`symbol`
      }
      if (!is.null(OptionUnusualTradeObject$`timestamp`)) {
        self$`timestamp` <- OptionUnusualTradeObject$`timestamp`
      }
      if (!is.null(OptionUnusualTradeObject$`type`)) {
        self$`type` <- OptionUnusualTradeObject$`type`
      }
      if (!is.null(OptionUnusualTradeObject$`total_value`)) {
        self$`total_value` <- OptionUnusualTradeObject$`total_value`
      }
      if (!is.null(OptionUnusualTradeObject$`contract_type`)) {
        self$`contract_type` <- OptionUnusualTradeObject$`contract_type`
      }
      if (!is.null(OptionUnusualTradeObject$`contract_expiration`)) {
        self$`contract_expiration` <- OptionUnusualTradeObject$`contract_expiration`
      }
      if (!is.null(OptionUnusualTradeObject$`contract_strike`)) {
        self$`contract_strike` <- OptionUnusualTradeObject$`contract_strike`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(OptionUnusualTradeJson) {
      OptionUnusualTradeObject <- jsonlite::fromJSON(OptionUnusualTradeJson, simplifyDataFrame = FALSE)
      self$setFromList(OptionUnusualTradeObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`symbol`)) {
        self$`symbol` <- listObject$`symbol`
      }
      else {
        self$`symbol` <- NA 
      }




      if (!is.null(listObject$`timestamp`)) {
        self$`timestamp` <- self$`timestamp` <- as.Date(listObject$`timestamp`, "%Y-%m-%d")
      }
      else {
        self$`timestamp` <- NA 
      }





      if (!is.null(listObject$`type`)) {
        self$`type` <- listObject$`type`
      }
      else {
        self$`type` <- NA 
      }

      if (!is.null(listObject$`total_value`)) {
        self$`total_value` <- listObject$`total_value`
      }
      else {
        self$`total_value` <- NA 
      }

      if (!is.null(listObject$`contract_type`)) {
        self$`contract_type` <- listObject$`contract_type`
      }
      else {
        self$`contract_type` <- NA 
      }




      if (!is.null(listObject$`contract_expiration`)) {
        self$`contract_expiration` <- self$`contract_expiration` <- as.Date(listObject$`contract_expiration`, "%Y-%m-%d")
      }
      else {
        self$`contract_expiration` <- NA 
      }





      if (!is.null(listObject$`contract_strike`)) {
        self$`contract_strike` <- listObject$`contract_strike`
      }
      else {
        self$`contract_strike` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["symbol"]] <- self$`symbol`

      listObject[["timestamp"]] <- self$`timestamp`



        
      listObject[["type"]] <- self$`type`
      listObject[["total_value"]] <- self$`total_value`
      listObject[["contract_type"]] <- self$`contract_type`

      listObject[["contract_expiration"]] <- self$`contract_expiration`



        
      listObject[["contract_strike"]] <- self$`contract_strike`
      return(listObject)
    }
  )
)
